-- RWL --

GUI = {}
GUI.mode = "menu"
GUI.flashtick = 0
GUI.dimtick = 0
GUI.startfade = 0
GUI.menutick = 0
GUI.newscore = false

btnwidth = 40 * 3
btnheight = 14 * 3
Btn = {}
Btn["start"] = {x=resx/2,y=resy/2,w=40,img=Img.startbtn,m="menu"}
Btn["score"] = {x=resx/2,y=resy/2+70,w=40,img=Img.scorebtn,m="menu"}
Btn["exit"] = {x=resx/2,y=resy/2+140,w=40,img=Img.exitbtn,m="menu"}
Btn["ok1"] = {x=resx/2,y=resy/2+195-btnheight,w=40,img=Img.okbtn,m="game"}
Btn["pause"] = {x=50,y=50,w=13,img=Img.pausebtn,m="game"}
Btn["resume"] = {x=50,y=50,w=13,img=Img.resumebtn,m="pause"}
Btn["pausemenu"] = {x=resx/2,y=resy-50,w=40,img=Img.menubtn,m="pause"}
Btn["gamemenu1"] = {x=resx/2,y=resy/2+195+70-btnheight,w=40,img=Img.menubtn,m="game"}
Btn["scoremenu"] = {x=resx/2,y=resy-50,w=40,img=Img.menubtn,m="score"}

function GUI.draw()
	
	if GUI.mode == "menu" then
		
		if love.mouse.getX() >= resx-48 * 3 and love.mouse.getY()  >= resy - 9 * 3 and love.system.getOS() == "Windows" then
			love.graphics.setColor(120,120,120,200)
		else
			love.graphics.setColor(120,120,120,100)
		end
		love.graphics.rectangle("fill",resx-48*3,resy-8*3,48*3,8*3)
		if love.mouse.getX() <= 26 * 3 and love.mouse.getY()  >= resy - 9 * 3 and love.system.getOS() == "Windows" then
			love.graphics.setColor(120,120,120,200)
		else
			love.graphics.setColor(120,120,120,100)
		end
		love.graphics.rectangle("fill",0,resy-9*3,26*3,9*3)
		
		love.graphics.setColor(255,255,255)
		love.graphics.draw(Img.flappybling,resx/2-Img.flappybling:getWidth()/2*3,Bird.y-Img.flappybling:getHeight()/2*3,0,3,3)
		love.graphics.draw(Img.credit,0,resy-Img.credit:getHeight()*3,0,3,3)
		drawButton("start")
		drawButton("score")
		drawButton("exit")
		
	elseif GUI.mode == "score" then
		love.graphics.setColor(210,210,210)
		love.graphics.draw(Img.highscore,resx/2-Img.highscore:getWidth()*3+100,100-Img.highscore:getHeight()/2*3,0,3,3)
		love.graphics.draw(Img.totalscore,resx/2-Img.totalscore:getWidth()*3+100,200-Img.totalscore:getHeight()/2*3,0,3,3)
		love.graphics.draw(Img.distance,resx/2-Img.distance:getWidth()*3+100,300-Img.distance:getHeight()/2*3,0,3,3)
		love.graphics.draw(Img.timesplayed,resx/2-Img.timesplayed:getWidth()*3+100,400-Img.timesplayed:getHeight()/2*3,0,3,3)
		love.graphics.setColor(255,255,255)
		drawNumbers(Settings.highscore,resx/2+110,100-10/2*3,3)
		drawNumbers(math.floor(Settings.totalscore),resx/2+110,200-10/2*3,3)
		drawNumbers(math.floor(Settings.distance),resx/2+110,300-10/2*3,3)
		drawNumbers(math.floor(Settings.timesplayed),resx/2+110,400-10/2*3,3)
		drawButton("scoremenu")
		
	elseif GUI.mode == "tutorial" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(Img.tutorial,resx/2-Img.tutorial:getWidth()/2*3,resy/2-Img.tutorial:getHeight()/2*3,0,3,3)
		love.graphics.draw(Img.getready,resx/2-Img.getready:getWidth()/2*3,100,0,3,3)
		
	elseif GUI.mode == "game" or GUI.mode == "pause" then
		love.graphics.setColor(255,255,255)
		drawNumbers(Settings.score,resx/2-#tostring(Settings.score)*4*3,20,3)
		
		if love.timer.getTime() < GUI.startfade + 3 then
			love.graphics.setColor(255,255,255,math.max(255-(love.timer.getTime()-GUI.startfade)*400,0))
			love.graphics.draw(Img.tutorial,resx/2-Img.tutorial:getWidth()/2*3,resy/2-Img.tutorial:getHeight()/2*3,0,3,3)
			love.graphics.draw(Img.getready,resx/2-Img.getready:getWidth()/2*3,100,0,3,3)
		end
		
		if Bird.alive and GUI.mode == "game" then
			love.graphics.setColor(255,255,255,255-math.max(255-(love.timer.getTime()-GUI.startfade)*400,0))
			drawButton("pause")
		elseif GUI.mode == "pause" then
			love.graphics.setColor(255,255,255)
			drawButton("resume")
			drawButton("pausemenu")
		end
		
	end
	
	if GUI.menutick > 0 then
		love.graphics.setColor(255,255,255,math.min((love.timer.getTime()-GUI.menutick)*300,255))
		love.graphics.draw(Img.gameover,resx/2-Img.gameover:getWidth()/2*3,100,0,3,3)
		love.graphics.setColor(255,255,255)
		y = resy-math.min((love.timer.getTime()-GUI.menutick)*500,resy/2+Img.scorewindow:getHeight()/2*3)
		love.graphics.draw(Img.scorewindow,resx/2-Img.scorewindow:getWidth()/2*3,y,0,3,3)
		drawNumbers(Settings.score,resx/2+120-#tostring(Settings.score)*2.5*8,y+50,2.5)
		drawNumbers(Settings.highscore,resx/2+120-#tostring(Settings.highscore)*2.5*8,y+115,2.5)
		if GUI.newscore then
			love.graphics.draw(Img.new,resx/2+30,y+88,0,3,3)
		end
		if Settings.score >= 30 then
			love.graphics.draw(Img.gold,resx/2-130,y+65,0,3,3)
		elseif Settings.score >= 20 then
			love.graphics.draw(Img.silver,resx/2-130,y+65,0,3,3)
		elseif Settings.score >= 10 then
			love.graphics.draw(Img.bronze,resx/2-130,y+65,0,3,3)
		end
		Btn["ok1"].y = y+220
		Btn["gamemenu1"].y = y+220+70
		drawButton("ok1")
		drawButton("gamemenu1")
	end
	
	if GUI.flashtick > 0 then
		love.graphics.setColor(255,255,255,(math.sin((love.timer.getTime()-GUI.flashtick)*20)+1)*100)
		love.graphics.rectangle("fill",0,0,resx,resy)
		if love.timer.getTime() > GUI.flashtick + 0.24 then
			GUI.flashtick = 0
		end
	end
	if GUI.dimtick > 0 then
		love.graphics.setColor(0,0,0,200-math.min((love.timer.getTime()-GUI.dimtick)*1000,200))
		love.graphics.rectangle("fill",0,0,resx,resy)
		if love.timer.getTime() > GUI.dimtick + 0.24 then
			GUI.dimtick = 0
		end
	end
	
end

function GUI.keypressed(k)
	if GUI.mode == "tutorial" then
		if k == " " then
			Level.highest = (Bird.x+resx)/(26*3*3)-2
			GUI.mode = "game"
			Bird.vy = Bird.jumpv
			sound.flap:play()
			GUI.startfade = love.timer.getTime()
		elseif k == "escape" then
			GUI.mode = "menu"
			Level.reset()
		end
	elseif GUI.mode == "game" then
		if k == " " and Bird.alive then
			Bird.vy = Bird.jumpv
			sound.flap:stop()
			sound.flap:play()
		elseif k == "escape" then
			if Bird.alive then
				GUI.mode = "pause"
			else
				GUI.mode = "menu"
				Level.reset()
			end
		end
	elseif GUI.mode == "pause" then
		if k == "escape" then
			GUI.mode = "game"
		end
	elseif GUI.mode == "menu" then
		if k == "escape" then
			love.event.quit()
		end
	elseif GUI.mode == "score" then
		if k == "escape" then
			GUI.mode = "menu"
			GUI.dimtick = love.timer.getTime()
			sound.swoosh:stop()
			sound.swoosh:play()
		end
	end
end

function GUI.mousepressed(x,y)
	GUI.btnpressed = false
	for k,v in pairs (Btn) do
		if v.m == GUI.mode and x > v.x - v.w/2 * 3 and x < v.x + v.w/2 * 3 and y > v.y - 7 * 3 and y < v.y + 7 * 3 then
			if k == "start" then
				GUI.dimtick = love.timer.getTime()
				GUI.mode = "tutorial"
				Bird.y = resy/2-56
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "score" then
				Bird.y = 100
				GUI.mode = "score"
				GUI.dimtick = love.timer.getTime()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "exit" then
				love.event.quit()
			elseif k == "ok1" and love.timer.getTime() > GUI.menutick + 0.8 and GUI.menutick > 0 then
				GUI.mode = "tutorial"
				Level.reset()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "ok2" and love.timer.getTime() > GUI.menutick + 0.8 and GUI.menutick > 0 then
				GUI.mode = "tutorial"
				Level.reset()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "gamemenu1" and love.timer.getTime() > GUI.menutick + 0.8 and GUI.menutick > 0 then
				GUI.mode = "menu"
				Level.reset()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "gamemenu2" and love.timer.getTime() > GUI.menutick + 0.8 and GUI.menutick > 0 then
				GUI.mode = "menu"
				Level.reset()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "pause" and Bird.alive then
				GUI.mode = "pause"
				return
			elseif k == "resume" then
				GUI.mode = "game"
				return
			elseif k == "pausemenu" then
				GUI.mode = "menu"
				Level.reset()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			elseif k == "scoremenu" then
				GUI.mode = "menu"
				GUI.dimtick = love.timer.getTime()
				sound.swoosh:stop()
				sound.swoosh:play()
				return
			end
		end
	end
	
	if GUI.mode == "menu" and y >= resy - 9 * 3 then
		if x >= resx - 48 * 3 then
			love.system.openURL("http://bit.ly/1asUQhT")
		elseif x <= 26 * 3 then
			love.system.openURL("http://love2d.org/")
		end
	elseif GUI.mode == "splash" and love.timer.getTime() > opentick + 0.5 then
		GUI.mode = "menu"
	elseif GUI.mode == "game" and Bird.alive then
		Bird.vy = Bird.jumpv
		sound.flap:stop()
		sound.flap:play()
	elseif GUI.mode == "tutorial" then
		Level.highest = (Bird.x+resx)/(26*3*3)-2
		GUI.mode = "game"
		Bird.vy = Bird.jumpv
		sound.flap:play()
		GUI.startfade = love.timer.getTime()
	end
end

function drawButton(name)
	if love.mouse.getX() > Btn[name].x - Btn[name].w/2*3 and love.mouse.getX() < Btn[name].x + Btn[name].w/2*3 and love.mouse.getY() > Btn[name].y - btnheight/2 and love.mouse.getY() < Btn[name].y + btnheight/2 then
		love.graphics.draw(Btn[name].img,Btn[name].x - Btn[name].w/2 * 3,Btn[name].y + 2 - 7 * 3,0,3,3)
	else
		love.graphics.draw(Btn[name].img,Btn[name].x - Btn[name].w/2 * 3,Btn[name].y - 7 * 3,0,3,3)
	end
end