-- RWL --

Bird = {}

Bird.r = 0
Bird.x = 0
Bird.vx = 180
Bird.offX = 200
Bird.y = resy/2-56
Bird.vy = 0
Bird.jumpv = -450
Bird.q = 1
Bird.dt = 0
Bird.height = 12*3
Bird.alive = true
Bird.lastPoint = 0

function Bird.draw()
	love.graphics.setColor(255,255,255)
	love.graphics.draw(Img.bird[Bird.q],getDrawX(Bird.offX,Bird.r,17*3,12*3),getDrawY(Bird.y,Bird.r,17*3,12*3),Bird.r,3,3)
end

function Bird.update(dt)
	
	if GUI.mode == "game" then
		
		-- movement --
		Bird.vy = Bird.vy+1300*dt
		Bird.y = Bird.y + Bird.vy * dt
		if Bird.alive then
			Bird.x = Bird.x + Bird.vx * dt
		end
		
		if Bird.y > resy-56*2-10 then
			Bird.y = resy-56*2-10
			Bird.vy = 0
			Bird.r = math.pi/2
			if Bird.alive then
				Bird.die()
			end
		elseif Bird.y < 0 then
			Bird.y = 0
			Bird.vy = 0
			Bird.r = math.pi/2
		else
			Bird.r = math.max(math.min(Bird.vy/200-1,math.pi/2),-math.pi/8)
		end
		
	elseif GUI.mode == "tutorial" then
		Bird.r = 0
		Bird.x = Bird.x + Bird.vx * dt
		
	elseif GUI.mode == "menu" then
		Bird.r = 0
		Bird.y = math.sin(love.timer.getTime()*8.5)*10+150
		Bird.x = Bird.x + Bird.vx * dt
		
	elseif GUI.mode == "score" then
		Bird.x = Bird.x + Bird.vx * dt
		
	end
	
	if Bird.alive then
		
		--Collision--
		for k,v in pairs (Level.obstacles) do
			if Bird.offX > v.x-Bird.x-15 and Bird.offX < v.x+26*3-Bird.x+15  then
				if Bird.y > v.y+Level.gap/2-10 or Bird.y < v.y-Level.gap/2+10 then
					sound.die:play()
					Bird.die()
				end
				
				if Bird.x > Bird.lastPoint + 26*3*2 and Bird.alive then
					Settings.score = Settings.score + 1
					Settings.totalscore = Settings.totalscore + 1
					sound.point:play()
					Bird.lastPoint = Bird.x
				end
			end
		end
		
		Settings.distance = Settings.distance + dt
		
		Bird.dt = Bird.dt + dt
		if Bird.dt > 0.1 then
			Bird.dt = Bird.dt - 0.1
			Bird.q = Bird.q + 1
			if Bird.q > 4 then
				Bird.q = 1
			end
		end
		
	end
	
end

function Bird:die()
	Bird.alive = false
	sound.hit:play()
	Bird.vy = math.max(Bird.vy,0)
	GUI.flashtick = love.timer.getTime()
	if Settings.score > Settings.highscore then
		Settings.highscore = Settings.score
		GUI.newscore = true
		Settings.save()
	end
	GUI.menutick = love.timer.getTime()
	Settings.timesplayed = Settings.timesplayed + 1
end

function getDrawX(val,rot,w,h)
	return val - w/2 * math.cos(rot) + h/2 * math.sin(rot)
end
function getDrawY(val,rot,w,h)
	return val - h/2 * math.cos(rot) - w/2 * math.sin(rot)
end